// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate;

import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JComponent;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.DefaultActionGroup;
import com.intellij.openapi.actionSystem.ActionManager;

import com.kiwisoft.utils.Disposable;
import com.kiwisoft.utils.ListenerSupport;
import com.kiwisoft.generate.model.UserType;
import com.kiwisoft.generate.model.ParameterBean;

/**
 * A panel for a user type property.
 *
 * @author Stefan Stiller
 */
class GroupPanel extends JPanel implements Disposable
{
	private ListenerSupport listenerSupport=new ListenerSupport();

	public GroupPanel(ParameterBean bean, UserType modelType, AnAction removeAction)
	{
		DefaultActionGroup actionGroup=new DefaultActionGroup("KiwiCreate.ParameterDialog", false);
		actionGroup.add(removeAction);
		ActionManager actionManager=ActionManager.getInstance();
		JComponent toolbar=actionManager.createActionToolbar("KiwiCreate.ParameterDialog", actionGroup, false).getComponent();
		toolbar.setOpaque(false);

		JPanel parametersPanel=new JPanel();
		ParameterDialog.initializeParameterGroupPanel(parametersPanel, bean, modelType, listenerSupport);

		setLayout(new BorderLayout());
		add(parametersPanel, BorderLayout.CENTER);
		add(toolbar, BorderLayout.EAST);
	}

	public void dispose()
	{
		listenerSupport.dispose();
	}
}
