// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.formats;

import javax.swing.Icon;

import com.kiwisoft.utils.format.DefaultObjectFormat;
import com.kiwisoft.utils.StringUtils;
import com.kiwisoft.utils.gui.Icons;
import com.kiwisoft.generate.model.Parameter;

/**
 * Class used for formatting and rendering of {@link Parameter} objects.
 *
 * @author Stefan Stiller
 */
public class ParameterFormat extends DefaultObjectFormat
{
	public ParameterFormat()
	{
		super(DEFAULT);
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && Parameter.class.isAssignableFrom(aClass);
	}

	public String format(Object value)
	{
		if (value instanceof Parameter)
		{
			String name=((Parameter)value).getName();
			if (StringUtils.isEmpty(name)) return "<Unnamed Parameter>";
			return name;
		}
		return super.format(value);
	}

	public Icon getIcon(Object value)
	{
		return Icons.getIcon("model.parameter");
	}
}
