// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.formats;

import javax.swing.Icon;

import com.kiwisoft.utils.format.DefaultObjectFormat;
import com.kiwisoft.utils.StringUtils;
import com.kiwisoft.utils.gui.Icons;
import com.kiwisoft.generate.model.Type;
import com.kiwisoft.generate.model.UserType;

/**
 * Class used for formatting and rendering of {@link Type} objects.
 *
 * @author Stefan Stiller
 */
public class TypeFormat extends DefaultObjectFormat
{
	public TypeFormat()
	{
		super(DEFAULT);
	}

	public boolean canFormat(Class aClass)
	{
		return aClass!=null && Type.class.isAssignableFrom(aClass);
	}

	public String format(Object value)
	{
		if (value instanceof Type)
		{
			String name=((Type)value).getName();
			if (StringUtils.isEmpty(name)) return "<Unnamed Type>";
			return name;
		}
		return super.format(value);
	}

	public Icon getIcon(Object value)
	{
		if (value instanceof UserType) return Icons.getIcon("model.class");
		return super.getIcon(value);
	}
}
