// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model;

/**
 * A type representing decimal numbers.
 *
 * @author Stefan Stiller
 */
public class DecimalType implements Type
{
	public String getName()
	{
		return "Decimal";
	}

	public String getDisplayableName()
	{
		return "Decimal Number";
	}

	public Class getTypeClass()
	{
		return Double.class;
	}

	public Object parse(String name)
	{
		try
		{
			return new Double(name);
		}
		catch (NumberFormatException e)
		{
			return null;
		}
	}

	public String format(Object value)
	{
		if (value instanceof Double) return value.toString();
		return null;
	}

}
