// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model.ui;

import java.awt.GridBagConstraints;
import static java.awt.GridBagConstraints.*;
import java.awt.Insets;
import javax.swing.*;

import com.kiwisoft.generate.model.SystemParameter;
import com.kiwisoft.generate.model.Type;
import com.kiwisoft.utils.format.FormatManager;
import com.kiwisoft.utils.format.ObjectFormat;

/**
 * A panel containing details for a hard coded parameter. 
 *
 * @author Stefan Stiller
 */
public class SystemParameterPanel extends DetailsPanel<SystemParameter>
{
	public SystemParameterPanel(SystemParameter parameter)
	{
		super(parameter);
		initComponents();
	}

	private void initComponents()
	{
		JTextField nameField=new JTextField();
		nameField.setEditable(false);
		JTextArea descriptionField=new JTextArea();
		descriptionField.setEditable(false);
		descriptionField.setWrapStyleWord(true);
		descriptionField.setLineWrap(true);
		descriptionField.setRows(3);
		JScrollPane descriptionPanel=new JScrollPane(descriptionField);
		JTextField typeField=new JTextField();
		typeField.setEditable(false);

		int row=0;
		add(new JLabel("Name:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(nameField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("Description:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(descriptionPanel,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, BOTH, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("Type:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(typeField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(Box.createGlue(),
			new GridBagConstraints(0, row, 1, 1, 0.0, 1.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));

		nameField.setText(getObject().getName());
		descriptionField.setText(getObject().getDescription());
		ObjectFormat format=FormatManager.getInstance().getFormat(Type.class);
		typeField.setText((String)format.format(getObject().getType()));
	}
}
