// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model.ui;

import java.awt.GridBagConstraints;
import static java.awt.GridBagConstraints.*;
import java.awt.Insets;
import javax.swing.*;

import com.kiwisoft.generate.model.TemplateFile;
import com.kiwisoft.utils.gui.lookup.DialogLookupField;
import com.kiwisoft.utils.gui.lookup.TextDialogLookup;

/**
 * A panel for editing details of a template file. 
 *
 * @author Stefan Stiller
 */
public class TemplateFilePanel extends DetailsPanel<TemplateFile>
{
	public TemplateFilePanel(TemplateFile file)
	{
		super(file);
		initComponent();
	}

	private void initComponent()
	{
		JTextField nameField=new JTextField();
		DialogLookupField fileNameField=new DialogLookupField(new TextDialogLookup());
		JTextPane contentField=new JTextPane();
		JCheckBox overwriteField=new JCheckBox("Overwrite existing files");
		JCheckBox openEditorField=new JCheckBox("Open file in editor");

		int row=0;
		add(new JLabel("Name:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(nameField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("File Name Template:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(fileNameField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(overwriteField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(openEditorField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("File Content Template:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(new JScrollPane(contentField),
			new GridBagConstraints(0, row, 1, 1, 1.0, 1.0, WEST, BOTH, new Insets(0, 5, 5, 5), 0, 0));

		addAdapter(getListenerSupport().bind(nameField, getObject(), "name"));
		addAdapter(getListenerSupport().bind(fileNameField.getTextField(), getObject(), "fileName"));
		addAdapter(getListenerSupport().bind(contentField, getObject(), "content"));
		addAdapter(getListenerSupport().bind(overwriteField, getObject(), "overwrite"));
		addAdapter(getListenerSupport().bind(openEditorField, getObject(), "openEditor"));
	}

	public String getHelpTopic()
	{
		return "KiwiGenerator.file.details";
	}
}
