// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.generate.model.ui;

import java.awt.GridBagConstraints;
import static java.awt.GridBagConstraints.*;
import java.awt.Insets;
import javax.swing.*;

import com.kiwisoft.generate.model.UserType;

/**
 * A panel for editing details of a user type. 
 *
 * @author Stefan Stiller
 */
public class UserTypePanel extends DetailsPanel<UserType>
{
	public UserTypePanel(UserType type)
	{
		super(type);
		initComponents();
	}

	private void initComponents()
	{
		JTextField nameField=new JTextField();
		JTextField displayNameField=new JTextField();
		JTextArea descriptionField=new JTextArea();
		descriptionField.setWrapStyleWord(true);
		descriptionField.setLineWrap(true);
		descriptionField.setRows(3);
		JScrollPane descriptionPanel=new JScrollPane(descriptionField);

		int row=0;
		add(new JLabel("Name:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(nameField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("Display Name:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(displayNameField,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, HORIZONTAL, new Insets(0, 5, 5, 5), 0, 0));
		add(new JLabel("Description:"),
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, NONE, new Insets(5, 5, 5, 5), 0, 0));
		add(descriptionPanel,
			new GridBagConstraints(0, row++, 1, 1, 1.0, 0.0, WEST, BOTH, new Insets(0, 5, 5, 5), 0, 0));
		add(Box.createGlue(),
			new GridBagConstraints(0, row, 1, 1, 0.0, 1.0, CENTER, NONE, new Insets(0, 0, 0, 0), 0, 0));

		addAdapter(getListenerSupport().bind(nameField, getObject(), "name"));
		addAdapter(getListenerSupport().bind(displayNameField, getObject(), "displayName"));
		addAdapter(getListenerSupport().bind(descriptionField, getObject(), "description"));
	}

	public String getHelpTopic()
	{
		return "KiwiGenerator.type.details";
	}
}
