// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils;

/**
 * An event fired if a collection changes. 
 *
 * @author Stefan Stiller
 */
public class CollectionChangeEvent
{
	public static final int ADDED=0;
	public static final int REMOVED=1;
	public static final int CHANGED=2;

	private Object source;
	private String propertyName;
	private Object element;
	private int type;

	public CollectionChangeEvent(Object source, String propertyName, Object element, int type)
	{
		this.source=source;
		this.propertyName=propertyName;
		this.element=element;
		this.type=type;
	}

	public Object getSource()
	{
		return source;
	}

	public String getPropertyName()
	{
		return propertyName;
	}

	public Object getElement()
	{
		return element;
	}

	public int getType()
	{
		return type;
	}
}
