// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils;

import java.util.ResourceBundle;
import java.util.Locale;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.text.ParseException;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 17:48:08 $
 */
public class VersionInfo
{
	private String version;
	private String copyright;
	private String buildNumber;
	private Date builtDate;

	public VersionInfo(String bundleName)
	{
		ResourceBundle bundle=ResourceBundle.getBundle(bundleName, Locale.getDefault(), VersionInfo.class.getClassLoader());
		version=bundle.getString("version");
		copyright=bundle.getString("copyright");
		buildNumber=bundle.getString("build.number");
		try
		{
			builtDate=new SimpleDateFormat("d-M-yyyy").parse(bundle.getString("built.date"));
		}
		catch (ParseException e)
		{
			builtDate=new Date(0);
		}
	}

	public String getVersion()
	{
		return version;
	}

	public String getCopyright()
	{
		return copyright;
	}

	public Date getBuiltDate()
	{
		return builtDate;
	}

	public String getBuildNumber()
	{
		return buildNumber;
	}
}
