// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.format;

import com.kiwisoft.utils.StringComparator;

/**
 * An comparator which uses the Strings returned by {@link ObjectFormat}
 * to compare to objects.
 *
 * @author Stefan Stiller
 */
public class FormatStringComparator extends StringComparator
{
	public int compare(Object o1, Object o2)
	{
		FormatManager formatManager=FormatManager.getInstance();
		return super.compare(formatManager.getFormat(o1.getClass()).format(o1),
							 formatManager.getFormat(o2.getClass()).format(o2));
	}
}
