// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui;

import java.awt.Component;
import java.awt.Graphics;
import javax.swing.Icon;

/**
 * An icon which is a merge of two icons. 
 *
 * @author Stefan Stiller
 */
public class MergedIcon implements Icon
{
	private Icon icon1;
	private Icon icon2;
	private int x;
	private int y;
	private int height;
	private int width;

	public MergedIcon(Icon icon1, Icon icon2, int x, int y)
	{
		this.icon1=icon1;
		this.icon2=icon2;
		this.x=x;
		this.y=y;
		width=Math.max(icon1.getIconWidth(), x+icon2.getIconWidth());
		height=Math.max(icon1.getIconHeight(), y+icon2.getIconHeight());
	}

	public void paintIcon(Component c, Graphics g, int x, int y)
	{
		icon1.paintIcon(c, g, x, y);
		icon2.paintIcon(c, g, x+this.x, y+this.y);
	}

	public int getIconWidth()
	{
		return width;
	}

	public int getIconHeight()
	{
		return height;
	}
}
