// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.table;

import java.awt.Color;
import java.awt.Component;
import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;

import com.kiwisoft.utils.format.TextFormat;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.6 $, $Date: 2006/03/24 18:58:20 $
 */
public class DefaultObjectEditor extends DefaultCellEditor implements ObjectEditor
{
	private TextFormat format;
	private Class targetClass;

	public DefaultObjectEditor(Class targetClass, TextFormat format)
	{
		super(new JTextField());
		this.targetClass=targetClass;
		this.format=format;
	}

	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column)
	{
		JTextField textField=(JTextField)getComponent();
		textField.setHorizontalAlignment(format.getHorizontalAlignment(value));
		String text=format.format(value);
		return super.getTableCellEditorComponent(table, text, isSelected, row, column);
	}

	public Object getCellEditorValue()
	{
		return format.parse((String)super.getCellEditorValue(), targetClass);
	}

	public void setForeground(Color foreground)
	{
		getComponent().setForeground(foreground);
	}

	public void setBackground(Color background)
	{
		getComponent().setBackground(background);
	}

	public void setQuickEditable(boolean editable)
	{
	}

	public ObjectEditor cloneEditor()
	{
		return new DefaultObjectEditor(targetClass, format);
	}
}
