// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.table;

/**
 * A default implementation of {@link SortableTableModel}.
 *
 * @author Stefan Stiller
 */
public class DefaultSortableTableModel<T> extends SortableTableModel<T>
{
	private String[] columns;
	private boolean resortable;

	public DefaultSortableTableModel(String... columns)
	{
		this.columns=columns;
	}

	public String getColumnName(int column)
	{
		return columns[column];
	}

	public int getColumnCount()
	{
		return columns.length;
	}

	public void setResortable(boolean resortable)
	{
		this.resortable=resortable;
	}

	public boolean isResortable()
	{
		return resortable;
	}
}
