// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.table;

import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import javax.swing.KeyStroke;
import javax.swing.AbstractAction;
import javax.swing.ListSelectionModel;

/**
 * Created by IntelliJ IDEA.
 * User: Stefan1
 * Date: 05.11.2006
 * Time: 12:03:59
 * To change this template use File | Settings | File Templates.
 */
public class SetTable extends SortableTable
{
	public SetTable(Class type)
	{
		super(new SetTableModel(type));
		((SetTableModel)getModel()).setTable(this);
		getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0), "delete");
		getActionMap().put("delete", new DeleteAction());
		getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}

	private class DeleteAction extends AbstractAction
	{
		public void actionPerformed(ActionEvent e)
		{
			int selectedRow=getSelectedRow();
			if (selectedRow>=0)
			{
				SetTableModel model=(SetTableModel)getModel();
				SortableTableRow row=model.getRow(selectedRow);
				if (row instanceof SetTableModel.Row)
				{
					//noinspection unchecked
					model.removeRow(selectedRow);
					if (selectedRow<model.getRowCount())
					{
						getSelectionModel().setSelectionInterval(selectedRow, selectedRow);
					}
				}
			}
		}
	}
}
