// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.gui.table;

import java.awt.Component;
import java.awt.Color;
import java.awt.Font;
import javax.swing.table.TableCellRenderer;
import javax.swing.JTable;

import com.kiwisoft.utils.gui.ObjectStyle;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.5 $, $Date: 2006/03/24 18:50:48 $
 */
public class StyleRenderer implements TableCellRenderer
{
	private ObjectRenderer renderer;
	private ObjectStyle style;

	public StyleRenderer(ObjectRenderer renderer, ObjectStyle style)
	{
		this.renderer=renderer.cloneRenderer();
		this.style=style;
	}

	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
	{
		Color foreground=style.getForeground();
		if (foreground!=null) renderer.setCellForeground(foreground);
		Color background=style.getBackground();
		if (background!=null) renderer.setCellBackground(background);
		Font font=style.getFont();
		if (font!=null) renderer.setTextFont(font);
		renderer.setDecorators(style.getDecorators());
		return renderer.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
	}
}
