// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.velocity;

import java.util.Calendar;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

/**
 * A class with utility methods for Dates which can be used for Velocity templates. 
 *
 * @author Stefan Stiller
 */
public class DateTools
{
	private Calendar calendar=Calendar.getInstance();

	public DateTools()
	{
	}

	public int getYear()
	{
		return calendar.get(Calendar.YEAR);
	}

	public int getMonth()
	{
		return calendar.get(Calendar.MONTH)+1;
	}

	public int getDay()
	{
		return calendar.get(Calendar.DAY_OF_MONTH);
	}

	public String getToday()
	{
		return DateFormat.getDateInstance().format(calendar.getTime());
	}

	public String date(String pattern)
	{
		return new SimpleDateFormat(pattern).format(calendar.getTime());
	}
}
