// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.velocity;

import com.kiwisoft.utils.StringUtils;

/**
 * A class with utility methods for Strings which can be used in Velocity templates.
 *
 * @author Stefan Stiller
 */
public class StringTools
{
	public StringTools()
	{
	}

	public String capitalize(String value)
	{
		if (value==null || value.length()<1) return value;
		char[] characters=value.toCharArray();
		characters[0]=Character.toUpperCase(characters[0]);
		return new String(characters);
	}

	public String decapitalize(String value)
	{
		if (value==null || value.length()<1) return value;
		char[] characters=value.toCharArray();
		characters[0]=Character.toLowerCase(characters[0]);
		return new String(characters);
	}

	public String formatJavaIdentifier(String value)
	{
		return StringUtils.formatJavaProperty(value);
	}

	public String fillLeft(String s, String ch, int length)
	{
		StringBuilder buffer=new StringBuilder(s);
		while (buffer.length()<length) buffer.insert(0, ch);
		return buffer.toString();
	}

	public String fillRight(String s, String ch, int length)
	{
		StringBuilder buffer=new StringBuilder(s);
		while (buffer.length()<length) buffer.append(ch);
		return buffer.toString();
	}


}
