// Copyright (c) 2002-2006, Stefan Stiller.
package com.kiwisoft.utils.xml;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.3 $, $Date: 2006/03/24 17:48:08 $
 */
public class XMLException extends RuntimeException
{
	private Throwable throwable;

	public XMLException(String message)
	{
		super(message);
	}

	public XMLException(Throwable cause)
	{
		super(cause.getMessage());
		cause.printStackTrace();
		throwable=cause;
	}

	public Throwable getThrowable()
	{
		return throwable;
	}

	public void printStackTrace()
	{
		super.printStackTrace();
		if (throwable!=null)
		{
			System.err.println("Nested exception:");
			throwable.printStackTrace();
		}
	}

	public void printStackTrace(PrintStream s)
	{
		super.printStackTrace(s);
		if (throwable!=null)
		{
			s.println("Nested exception:");
			throwable.printStackTrace(s);
		}
	}

	public void printStackTrace(PrintWriter s)
	{
		super.printStackTrace(s);
		if (throwable!=null)
		{
			s.println("Nested exception:");
			throwable.printStackTrace(s);
		}
	}
}
